package mods.immibis.ars;


import java.util.List;

import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

import net.minecraft.client.renderer.texture.IconRegister;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.Icon;

public class ItemComponent extends Item {
	
	public static final int META_ENERGY_MODULATOR = 0;
	public static final int META_DIAMOND_LENS = 1;
	public static final int META_PROJECTOR_BASE = 2;
	
	private String[] internal_names;

	public ItemComponent(int id_minus256) {
		super(id_minus256);
		
		internal_names = new String[] {
			"item.immibis/ars:energy-modulator",
			"item.immibis/ars:diamond-lens",
			"item.immibis/ars:projector-base",
		};

		setMaxDamage(0);
        setHasSubtypes(true);
        
        setCreativeTab(CreativeTabs.tabMisc);
	}
	
	@Override
	public String getUnlocalizedName(ItemStack is) {
		try {
			return internal_names[is.getItemDamage()];
		} catch(ArrayIndexOutOfBoundsException e) {
			return "";
		}
	}
	
	private Icon[] icons;
	
	@Override
	@SideOnly(Side.CLIENT)
	public void registerIcons(IconRegister reg) {
		icons = new Icon[] {
			reg.registerIcon("immibis/ars:energy-modulator"),
			reg.registerIcon("immibis/ars:diamond-lens"),
			reg.registerIcon("immibis/ars:projector-base")
		};
	}
	
	@Override
	public Icon getIconFromDamage(int damage) {
		return damage < 0 || damage >= icons.length ? icons[0] : icons[damage];
	}
	
	@SuppressWarnings({ "rawtypes", "unchecked" })
	@Override
	public void getSubItems(int id, CreativeTabs tab, List list) {
		for(int meta = 0; meta < 3; meta++)
			list.add(new ItemStack(this, 1, meta));
	}

}
