package mods.immibis.ars.beams;

import ic2.api.item.Items;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import mods.immibis.ars.ARSMod;
import mods.immibis.ars.Functions;
import mods.immibis.ars.ItemComponent;
import net.minecraft.block.Block;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import cpw.mods.fml.common.ICraftingHandler;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

public class BeamsMain {
	public static BlockBeam blockBeam;
	public static BlockBeamStuff blockBeamMachines;
	public static ItemLogicCard itemLogicCard;
	
	public static int maxTeslaRange;
	
	private static int logicCardID, beamBlockID, machineBlockID;

	public static void init() {
		
		GameRegistry.registerTileEntity(TileProgrammableFilter.class, "AdvRepSys TileUpgradeUnit");
		GameRegistry.registerTileEntity(TileTeslaCoil.class, "AdvRepSys TileTeslaCoil");
		GameRegistry.registerTileEntity(TileUpgradeCombiner.class, "AdvRepSys UpgradeCombiner");
		GameRegistry.registerTileEntity(TileRangeUpgrade.class, "AdvRepSys RangeUpgrade");
		GameRegistry.registerTileEntity(TileEMPUpgrade.class, "AdvRepSys EMPUpgrade");
		GameRegistry.registerTileEntity(TileSpeedUpgrade.class, "AdvRepSys SpeedUpgrade");
		GameRegistry.registerTileEntity(TileLootCollector.class, "AdvRepSys LootCollector");
		GameRegistry.registerTileEntity(TileFieldFilter.class, "AdvRepSys FieldFilter");
		GameRegistry.registerTileEntity(TileInventoryContentsFilter.class, "AdvRepSys InventoryContentsFilter");
		GameRegistry.registerTileEntity(TilePotionUpgrade.class, "AdvRepSys PotionUpgrade");
		GameRegistry.registerTileEntity(TileSuppressorUpgrade.class, "AdvRepSys SuppressorUpgrade");
		
		itemLogicCard = new ItemLogicCard(logicCardID - 256);
		blockBeam = new BlockBeam(beamBlockID);
		blockBeamMachines = new BlockBeamStuff(machineBlockID);
		
		maxTeslaRange = Functions.getBalanceOption("maxTeslaRange", 100);

		try {
			Method m = BeamsMain.class.getDeclaredMethod("initClient");
			m.invoke(null);
		} catch(NoSuchMethodException e) {
		} catch (IllegalAccessException e) {
			throw new RuntimeException(e);
		} catch (InvocationTargetException e) {
			throw new RuntimeException(e);
		}
		
		ItemStack progFilter = new ItemStack(blockBeamMachines, 1, 0);
		ItemStack teslaCoil = new ItemStack(blockBeamMachines, 1, 1);
		ItemStack upgradeCombiner = new ItemStack(blockBeamMachines, 1, 2);
		ItemStack rangeUpgrade = new ItemStack(blockBeamMachines, 1, 3);
		ItemStack empUpgrade = new ItemStack(blockBeamMachines, 1, 4);
		ItemStack speedUpgrade = new ItemStack(blockBeamMachines, 1, 5);
		ItemStack lootCollector = new ItemStack(blockBeamMachines, 1, 6);
		ItemStack fieldFilter = new ItemStack(blockBeamMachines, 1, 7);
		ItemStack invFilter = new ItemStack(blockBeamMachines, 1, 8);
		ItemStack suppressor = new ItemStack(blockBeamMachines, 1, 9);
		ItemStack potionApplicator = new ItemStack(blockBeamMachines, 1, 10);
		
		Object energyModulator = new ItemStack(ARSMod.itemComponent, 1, ItemComponent.META_ENERGY_MODULATOR);
		
		Object refinedIron = Items.getItem("refinedIronIngot");
		//Object copper = Items.getItem("copperIngot");
		
		GameRegistry.addRecipe(teslaCoil,
			" # ",
			" | ",
			"-H-",
			'#', Block.blockIron,
			'|', Item.ingotIron,
			'H', Items.getItem("hvTransformer"),
			'-', Items.getItem("glassFiberCableItem")
		);
		
		GameRegistry.addRecipe(copyStackWithCount(progFilter, 4),
			"I^I",
			".M.",
			"C.C",
			'M', Items.getItem("machine"),
			'C', Items.getItem("electronicCircuit"),
			'I', refinedIron,
			'.', Block.glass,
			'^', Block.torchRedstoneActive
		);
		
		GameRegistry.addRecipe(copyStackWithCount(upgradeCombiner, 4),
			"G^G",
			".M.",
			"G.G",
			'G', Item.ingotGold,
			'M', Items.getItem("machine"),
			'^', Block.torchRedstoneActive,
			'.', Block.glass
		);
		
		GameRegistry.addRecipe(rangeUpgrade,
			"I^I",
			"CMC",
			"CCC",
			'I', refinedIron,
			'C', Items.getItem("copperCableItem"),
			'^', Block.torchRedstoneActive,
			'M', Items.getItem("machine")
		);
		
		GameRegistry.addRecipe(empUpgrade,
			"I^I",
			"CTC",
			"OCO",
			'I', refinedIron,
			'^', Block.torchRedstoneActive,
			'T', Items.getItem("mvTransformer"),
			'O', Item.enderPearl,
			'C', Items.getItem("glassFiberCableItem")
		);
		
		GameRegistry.addRecipe(speedUpgrade,
			"I^I",
			"SMS",
			"SSS",
			'I', refinedIron,
			'^', Block.torchRedstoneActive,
			'M', Items.getItem("machine"),
			'S', Item.sugar
		);
		
		GameRegistry.addRecipe(lootCollector,
			"I^I",
			"OMO",
			"OOO",
			'I', refinedIron,
			'^', Block.torchRedstoneActive,
			'M', Items.getItem("machine"),
			'O', Item.eyeOfEnder
		);
		
		GameRegistry.addRecipe(potionApplicator,
			"I^I",
			"OMO",
			"BOB",
			'I', refinedIron,
			'^', Block.torchRedstoneActive,
			'O', Item.eyeOfEnder,
			'M', Items.getItem("machine"),
			'B', Item.glassBottle
		);
		
		GameRegistry.addRecipe(suppressor,
			"I^I",
			"IMI",
			"ICI",
			'I', refinedIron,
			'^', Block.torchRedstoneActive,
			'M', Items.getItem("machine"),
			'C', Items.getItem("advancedCircuit")
		);
		
		GameRegistry.addShapelessRecipe(fieldFilter,
			progFilter,
			energyModulator
		);
		
		GameRegistry.addShapelessRecipe(invFilter,
			progFilter,
			Item.enderPearl
		);
		
		ItemStack blankToken = new ItemStack(itemLogicCard, 1, LogicType.ID_BLANK);
		
		GameRegistry.addRecipe(copyStackWithCount(blankToken, 16),
			" P ",
			"PRP",
			" P ",
			'P', Item.paper,
			'R', Item.redstone
		);
		
		GameRegistry.addShapelessRecipe(new ItemStack(itemLogicCard, 1, LogicType.ID_PLAYER), blankToken, Item.appleRed);
		GameRegistry.addShapelessRecipe(new ItemStack(itemLogicCard, 1, LogicType.ID_LIVING), blankToken, Item.sugar);
		GameRegistry.addShapelessRecipe(new ItemStack(itemLogicCard, 1, LogicType.ID_REDSTONE), blankToken, Item.redstone);
		GameRegistry.addShapelessRecipe(new ItemStack(itemLogicCard, 1, LogicType.ID_ANIMAL), blankToken, Item.porkRaw);
		GameRegistry.addShapelessRecipe(new ItemStack(itemLogicCard, 1, LogicType.ID_MOB), blankToken, Item.rottenFlesh);
		GameRegistry.addShapelessRecipe(new ItemStack(itemLogicCard, 1, LogicType.ID_ITEM), blankToken, Item.ingotIron);
		
		GameRegistry.addRecipe(new ItemStack(itemLogicCard, 1, LogicType.ID_AND),
			"!!!",
			"!C!",
			"! !",
			'C', blankToken,
			'!', Item.redstone
		);
		GameRegistry.addRecipe(new ItemStack(itemLogicCard, 1, LogicType.ID_OR),
			"! !",
			"!C!",
			"!!!",
			'C', blankToken,
			'!', Item.redstone
		);
		GameRegistry.addRecipe(new ItemStack(itemLogicCard, 1, LogicType.ID_INVERT),
			"!!!",
			" C ",
			'C', blankToken,
			'!', Item.redstone
		);
		
		for(int k = 0; k < 6; k++) {
			GameRegistry.addShapelessRecipe(new ItemStack(itemLogicCard, 1, LogicType.ID_INPUT[k]),
				blankToken,
				new ItemStack(Item.dyePowder, 1, LogicType.DYE_COLOURS[k]));
			
			GameRegistry.addRecipe(new ItemStack(itemLogicCard, 1, LogicType.ID_INPUT[(k+1)%6]),
				"X",
				'X', new ItemStack(itemLogicCard, 1, LogicType.ID_INPUT[k]));
		}
		
		GameRegistry.addRecipe(blankToken, "#", '#', new ItemStack(itemLogicCard, 1, -1));
		
		// Logic card crafting doesn't use the ingredients
		// it just "imprints" the card with them
		GameRegistry.registerCraftingHandler(new ICraftingHandler() {
			@Override public void onSmelting(EntityPlayer player, ItemStack item) {}			
			@Override public void onCrafting(EntityPlayer player, ItemStack item, IInventory craftMatrix) {
				if(item.getItem() == itemLogicCard && item.getItemDamage() != LogicType.ID_BLANK) {
					for(int k = 0; k < craftMatrix.getSizeInventory(); k++) {
						ItemStack is = craftMatrix.getStackInSlot(k);
						if(is != null && is.getItem() != itemLogicCard)
							is.stackSize++;
					}
				}
			}
		});
	}
	
	private static ItemStack copyStackWithCount(ItemStack s, int count) {
		s = s.copy();
		s.stackSize = count;
		return s;
	}
	
	@SideOnly(Side.CLIENT)
	public static void initClient() {
		cpw.mods.fml.client.registry.RenderingRegistry.registerEntityRenderingHandler(EntityBoltFX.class, new EntityBoltFXRenderer());
	}

	public static void readConfig() {
		logicCardID = Functions.getItemIdFor("itemLogicCard", "itemLogicCard", 11120);
		beamBlockID = Functions.getActualBlockIdFor("beam", "beam", 627);
		machineBlockID = Functions.getActualBlockIdFor("teslaMachines", "teslaMachines", 628);
	}
}
